#include "stdafx.h"

#include "choice.h"
#include "ff3se.h"
#include "resource.h"

ChoiceDialog choiceDialog;

/*************************************/
void ChoiceDialog::init(HWND hdlg)
{
	HWND hCtrl;
	RECT r;

	hDlg = hdlg;

	//Set the title
	if (title != NULL)
		SetWindowText(hDlg, title);
	else
		SetWindowText(hDlg, ff3seTitle);

	//Set the choices
	hCtrl = GetDlgItem(hDlg, IDC_CHOICE_1);
	SetWindowText(hCtrl, choice[0]);
	SendMessage(hCtrl, BM_SETCHECK, BST_CHECKED, 0);
	hCtrl = GetDlgItem(hDlg, IDC_CHOICE_2);
	SetWindowText(hCtrl, choice[1]);
	hCtrl = GetDlgItem(hDlg, IDC_CHOICE_3);
	if (choice[2][0] == '\0')
	{
		ShowWindow(hCtrl, SW_HIDE);
	}
	else
	{
		ShowWindow(hCtrl, SW_NORMAL);
		SetWindowText(hCtrl, choice[2]);
	}

	//Move window and display
	GetWindowRect(hWnd, &r);
	SetWindowPos(hDlg, HWND_NOTOPMOST, r.left + 150, r.top + 100, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
	UpdateWindow(hDlg);
}

/*************************************/
//Shows the choice dialog and returns the selection chosen
//Returns -1 if cancel was selected, 0 if choice 1 was selected,
//1 if choie 2 was selected, and 2 if choice 3 was selected
//choice1, choice2, and choice3 are the choices to choose from
//If choice3 is null, no third choice is shown
//name is the title to display in the dialog box, if NULL, the program title is shown
int ChoiceDialog::show(char *name, char *choice1, char *choice2, char *choice3)
{
	EnableWindow(hWnd, false);

	strcpy(title, name);
	strcpy(choice[0], choice1);
	strcpy(choice[1], choice2);
	if (choice3 == NULL)
		choice[2][0] = '\0';
	else
		strcpy(choice[2], choice3);

	return DialogBox(hInst, MAKEINTRESOURCE(IDD_CHOICE), hWnd, ::choiceProc);

}

/*************************************/
//Sets the turn value based on the selection chosen and closes the dialog
void ChoiceDialog::returnOK(HWND hdlg)
{
	int i;

	EnableWindow(hWnd, true);

	for (i = 0; i < 3; i++)
	{
		if (SendDlgItemMessage(hDlg, IDC_CHOICE_1 + i, BM_GETCHECK, 0, 0))
			EndDialog(hDlg, i);;
	}
}

/*************************************/
BOOL ChoiceDialog::choiceProc(HWND hdlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_ACTIVATE:
		init(hdlg);
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_CHOICE_OK:
			returnOK(hdlg);
			break;
		case IDC_CHOICE_CANCEL:
			EnableWindow(hWnd, true);
			EndDialog(hDlg, -1);
			break;
		}
		break;
	}

	return false;
}

/*************************************/
BOOL CALLBACK choiceProc(HWND hdlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return choiceDialog.choiceProc(hdlg, message, wParam, lParam);
}
